<?php
/**
* JSEOPlugin 2.1
* SEO Plugin for Joomla 1.5.x
* 
* @version 2.1 
* @author Leonid Tushov <gfk@mail.ru>
* @copyright 2010 Leonid Tushov
* @license http://www.opensource.org/licenses/lgpl-license.php LGPL
* @link http://tushov.ru
*/

defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.plugin.plugin');

class plgSystemJSEOPlugin extends JPlugin {

    var $appl;
    
    var $params; 
    
    var $document;
    
    var $buffer;
    
    var $content = null;
    
    var $host;
    
    var $_EXTLINKS_NOINDEX_PRE;
    
    var $_EXTLINKS_NOFOLLOW;
    
    var $_EXTLINKS_BLANK;
    
    var $_EXTLINKS_NOINDEX_POST;
    
    var $redirectVar;
    
    function plgSystemJSEOPlugin(&$subject, $config) {
        parent::__construct($subject, $config);
    
        $this->appl =& JFactory::getApplication();
        $this->document =& JFactory::getDocument();
        $plugin =& JPluginHelper::getPlugin('system', 'jseoplugin');
        $this->params = new JParameter($plugin->params);
        
        $this->url = JURI::base();
        $this->host = parse_url($this->url, PHP_URL_HOST);
        
        if ($_GET[$this->params->get('extlinks_rview')]) $this->redirect($_GET[$this->params->get('extlinks_rview')]);
        if ($this->params->get('extlinks_nofollow')) $this->_EXTLINKS_NOFOLLOW = ' rel="nofollow"'; 
        if ($this->params->get('extlinks_blank')) $this->_EXTLINKS_BLANK = ' target="_blank"'; 
        if ($this->params->get('extlinks_noindex')) {
            $this->_EXTLINKS_NOINDEX_PRE = '<noindex>';
            $this->_EXTLINKS_NOINDEX_POST = '</noindex>';
        }
                
        $this->redirectVar = trim($this->params->get('extlinks_rview')) == '' ? 'go' : $this->params->get('extlinks_rview');
        $this->redirectVar = $this->redirectVar . '=';
        
        if ($this->params->get('extlinks_redirect')) $this->_EXTLINKS_REDIRECT =  $_SERVER['HTTP_HOST'] . '/?' . $this->redirectVar;       
    } 
    
    function OnAfterDispatch()
    {
        if ($this->appl->isAdmin() or JRequest::getVar('no_html')) return;
        if (JRequest::getVar('format') == 'html' or JRequest::getVar('format') == '') {
            $this->buffer = current($this->document->_buffer['component']);
            $this->JSEOExec();
        }
    } 
    
    function JSEOExec()
    {
        // title generate
        if ($this->params->get('templateTitleOn')) {
            $templateTitle = $this->params->get('templateTitle');
            if (!strstr($templateTitle, '%TITLE%')) $templateTitle = "%TITLE% | $templateTitle";
            $this->document->setTitle(str_replace('%TITLE%', $this->document->getTitle(), $templateTitle));
        }
        // META TAGS
        // Description
        if ($this->params->get('onAutoDescription')) {
            $description = $this->document->getDescription();
            if (trim($description) == '' or $description == $this->appl->getCfg('MetaDesc')) {
                $desc = $this->getDescription();
                $desc = trim($desc) != '' ? $desc : $this->appl->getCfg('MetaDesc');
                $this->document->setDescription($desc);
            }
        }
        // Keywords
        if ($this->params->get('onAutoKeyWords')) {
            $keywords = $this->document->getMetaData('keywords');
            if (trim($keywords) == '' or $keywords == $this->appl->getCfg('MetaKeys')) {
                $keys = $this->getKeyWords();
                $keys = trim($keys) != '' ? $keys : $this->appl->getCfg('MetaKeys');
                $this->document->setMetaData('keywords', $keys);
            }
        }
        // generator        
        $this->document->setGenerator($this->params->get('metaGenerator'));
        
        // ROBOTS -> com_content
        if (JRequest::getVar('option') == 'com_content') {
            if (($this->params->get('noIndexSection') and JRequest::getVar('view') == 'section') or 
            ($this->params->get('noIndexCategory') and JRequest::getVar('view') == 'category') or
            ($this->params->get('noIndexArchive') and JRequest::getVar('view') == 'archive')) {
                $this->document->setMetaData('robots', 'noindex, follow');
            }
        }
    }
    
    function getDescription()
    {
        $content =& $this->getContent();
        if (function_exists('mb_substr')) {
            $length = strripos(mb_substr($content, 0, $this->params->get('descLength'), 'utf-8'), ' ');
            return mb_substr($content, 0, $length, 'utf-8');
        }
        else {
            $length = strripos(substr($content, 0, $this->params->get('descLength')), ' ');
            return substr($content, 0, $length);
        }
    }   
    
    function getStrLenght($str)
    {
        if (function_exists('mb_strlen')) {
            return mb_strlen($str, 'utf-8');
        }
        else {
            return strlen($str);
        }
    }
    
    function getKeyWords()
    {
        $words = explode(' ', str_replace(array('.', ',', '/', '\\', '=', '&', '$', ';', '`', '~', '@', '"', '%', '^', ':', '*', '(', ')', '+', '{', '}', '[', ']', '?', '>', '<', '|', '!', '@'), ' ', $this->getContent()));
        $words = array_count_values($words);
        if (count($words) == 0) return '';
        arsort($words);
        unset($words['']);
        $count = $this->params->get('KeyWordsCount');
        foreach ($words as $word => $c) {
            if ($this->getStrLenght($word) > 3) {
                $i++;
                $buff[] = $word;
            }
            if ($i > $count) break;
        }
        return @implode(', ', $buff);     
    }
    
    function textClean($text)
    {
        $text = preg_replace('|<script[^>]*?>.*?</script>|si', ' ', $text);
        $text = preg_replace('|<style[^>]*?>.*?</style>|si', ' ', $text);
        $cleanSymbol = array("\n", "\r", "\t", '`', '"', '>', '<');
        $text = html_entity_decode($text);
        $text = str_replace($cleanSymbol, ' ', strip_tags($text));
        $text = preg_replace('|[\s]{1,}|si', ' ', $text);
        return trim($text);
    }
    
    function getContent()
    {
        if (!$this->content) {
            $this->content = $this->textClean($this->buffer); 
        }
        return $this->content;
    }
    
    function translit($str) {
        $trans = array('а'=>'a', 'А'=>'A', 'б'=>'b', 'Б'=>'B', 'в'=>'v', 'В'=>'V', 'г'=>'g', 'Г'=>'G', 'д'=>'d', 'Д'=>'D', 'е'=>'e', 'Е'=>'E', 'ё'=>'e', 'Ё'=>'E', 'ж'=>'j', 'Ж'=>'J', 'з'=>'z', 'З'=>'Z', 'и'=>'i', 'И'=>'I', 'й'=>'i', 'Й'=>'I', 'к'=>'k', 'К'=>'K', 'л'=>'l', 'Л'=>'L', 'м'=>'m', 'М'=>'M', 'н'=>'n', 'Н'=>'N', 'о'=>'o', 'О'=>'O', 'п'=>'p', 'П'=>'P', 'р'=>'r', 'Р'=>'R', 'с'=>'s', 'С'=>'S', 'т'=>'t', 'Т'=>'T', 'у'=>'y', 'У'=>'Y', 'ф'=>'f', 'Ф'=>'F', 'х'=>'h', 'Х'=>'H', 'ц'=>'c', 'Ц'=>'C', 'ч'=>'ch', 'Ч'=>'CH', 'ш'=>'sh', 'Ш'=>'SH', 'щ'=>'sh', 'Щ'=>'SH', 'ъ'=>'', 'Ъ'=>'', 'ы'=>'y', 'Ы'=>'Y', 'ь'=>'', 'Ь'=>'', 'э'=>'e', 'Э'=>'E', 'ю'=>'u', 'Ю'=>'U', 'я'=>'ia', 'Я'=>'IA', ' '=>'-');
        return strtr($str, $trans);
    } 
    
    function onAfterInitialise()
    {
        $sizeAlias = $this->params->get('sizeAlias') ? $this->params->get('sizeAlias') : 100;
        if ($this->params->get('onAutoAlias')) {
            $alias = JRequest::getVar('alias', '', 'POST');
            if (trim($alias) == '') {
                if (trim(JRequest::getVar('title', '', 'POST')) != '') $alias = $this->translit(JRequest::getVar('title', '', 'POST'));
                if (trim(JRequest::getVar('name', '', 'POST')) != '') $alias = $this->translit(JRequest::getVar('name', '', 'POST'));
                JRequest::setVar('alias', substr($alias, 0, $sizeAlias));
            }
            else {
                JRequest::setVar('alias', substr($this->translit($alias), 0, $sizeAlias));
            }
        }
    }
    
    
    
    function redirect($url)
    { 
        @header('Location: http://' . $url);
        exit();
    }
    
    function extLinks($text)
    {
        if (trim($this->params->get('URIexcept')) != '') {
            $buff = explode("\n", $this->params->get('URIexcept'));
            if (count($buff) > 0) {
                foreach ($buff as $v) {
                    if (trim($v) != '') {
                        $exceptions[] = str_replace('http://', '', $v);
                    }                        
                }
            }
        }
        $exceptions[] = str_replace('www.', '', $this->host);
        $exceptions[] = 'www.' . $this->host;
        
        $text = preg_replace_callback('|<noextlinks>(.*?)</noextlinks>|is', array(&$this, 'noExtParse'), $text);
        
        $pattern = '|(?<!<noextlinks>)<a(.*?)href[\"\'\s]{0,}=[\"\'\s]{0,}(\w{3,5}://)';
        foreach ($exceptions as $except) {
            $pattern .= '(?!' . $except . ')';
        }            
        $pattern .= '(.*?)[\"\'\s]{1}(.*?)>(.*?)</a[\s]{0,}>(?!</noextlinks>)|i';
                
        $text = preg_replace_callback($pattern, array(&$this, 'parse'), $text);
        
        return $text;
    }
    
    function noExtParse($matches) {
        return preg_replace('|<a.*?href.*?>.*?</a[\s]{0,}>|is', '<noextlinks>$0</noextlinks>', $matches[1]);   
    }
    
    function onPrepareContent(&$row, &$params, $page=0 )
    {
        if ($this->params->get('extlinks_mode') == 1) {
            $row->text = $this->extLinks($row->text);
            return true;
        }
    }
    
    function parse($matches) 
    {
        $host = @parse_url($matches[2] . $matches[3], PHP_URL_HOST);
        if ($host != $this->host and $this->host != '') {
            if ($this->params->get('extlinks_redirect')) $matches[3] = urlencode(html_entity_decode($matches[3]));
            return $this->_EXTLINKS_NOINDEX_PRE . '<a' . $this->_EXTLINKS_NOFOLLOW . $this->_EXTLINKS_BLANK . ' href="' . $matches[2] . $this->_EXTLINKS_REDIRECT . $matches[3] . '" ' . $matches[1] . $matches[4] . '>' . $matches[5] . '</a>' . $this->_EXTLINKS_NOINDEX_POST;
        }
        else {
            return '<a href="'. $matches[2] . $matches[3] . '" ' . $matches[1] . $matches[4] . '>' . $matches[5] . '</a>';
        }        
    }
    
    function onAfterRender() {
        if ($this->appl->isAdmin() or $this->params->get('extlinks_mode') != 2) return;
        $body = JResponse::getBody();
        $body = $this->extLinks($body);
        $body = str_replace(array('<noextlinks>', '</noextlinks>'), '', $body);
        JResponse::setBody($body);
    }
}
?>